/***********************************************************************************************************************
 *
 * blueBill Resources - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it
 * SCM: https://java.net/hg/bluebill~resources-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.factsheet.xenocanto;

import it.tidalwave.bluebill.taxonomy.Finder;
import it.tidalwave.bluebill.taxonomy.Taxon;
import it.tidalwave.util.Id;
import it.tidalwave.util.NotFoundException;
import java.util.Locale;
import java.util.Map;
import java.util.SortedSet;
import org.openide.util.Lookup;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class PatchedTaxon implements Taxon
  {
    private final Id scientificNameId;

    public PatchedTaxon(Id scientificNameId)
      {
        this.scientificNameId = scientificNameId;
      }
    
    public Builder createSubTaxon() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Finder<Taxon> findSubTaxa() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Id getScientificNameId()
      {
        return scientificNameId;
      }

    public String getScientificName()
      {
        return scientificNameId.stringValue();
      }

    public String getSpecificEpithet() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Taxon getAnonymousSynonym() throws NotFoundException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Finder<Taxon> findSynonyms() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public String getDisplayName() 
      {
        return scientificNameId.stringValue();
      }

    public String getDisplayName(Locale locale) 
      {
        return scientificNameId.stringValue();
      }

    public Map<Locale, String> getDisplayNames() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public SortedSet<Locale> getLocales() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Lookup getLookup() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public <T> T as(Class<T> clazz) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public <T> T as(Class<T> clazz, NotFoundBehaviour<T> notFoundBehaviour) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
  }
